'From Squeak3.0 of 4 February 2001 [latest update: #3545] on 21 July 2001 at 2:44:54 pm'!

!Matrices class methodsFor: 'examples' stamp: 'jpwj 7/21/2001 14:40'!
exampleReadMe
  "examples are given in subClass class methods."! !


!Matrices2Dimensional class methodsFor: 'examples' stamp: 'jpwj 7/21/2001 14:09'!
exampleReadMe
   "see subClass class methods for examples"! !


!LowerTriangularMatrix class methodsFor: 'examples' stamp: 'jpwj 7/21/2001 14:32'!
example01
	"TriDiagonalMatrix example01."
   "create and answer a LowerTriangularMatrix"
    | lowerTriangular |
    lowerTriangular:= LowerTriangularMatrix new: 4 @ 4
                contents:#(1 2 3 4 5 6 7 8 9 10).
    ^lowerTriangular! !

!LowerTriangularMatrix class methodsFor: 'examples' stamp: 'jpwj 7/21/2001 14:31'!
example02
	"TriDiagonalMatrix example02."
   "create a LowerTriangularMatrix, convert it to a fullMatrix,
    and display it on a stream in fixed width format
    answering the stream contents. "
    | lowerTriangular fullMatrix stream |
    stream := WriteStream on: ' '.
    lowerTriangular := LowerTriangularMatrix example01.
    fullMatrix := lowerTriangular asMatrix.
    fullMatrix printOn: stream width: 3 decimal: 0.
    ^stream contents! !

!LowerTriangularMatrix class methodsFor: 'examples' stamp: 'jpwj 7/21/2001 14:32'!
exampleReadMe
   "class methods #example01 through #exampleNN demonstrate
some of the features provided by this class.  These examples
are designed to be evaluated in a Workspace with show it(printIt).
For example,  In a worspace evaluate the following line with show it
LowerTriangularMatrix example01

    Each example contains comments explaining the method.
   "! !


!Matrix class methodsFor: 'examples' stamp: 'jpwj 7/21/2001 14:16'!
example01
	"Matrix example01."
   "create and answer a matrix dimensioned 3 rows by 2 columns
    with the contents taken from an array. "
    | matrix |
    matrix := Matrix new: 3 @ 2 contents: #( 1 2 3 4 5 6).
    ^matrix
! !

!Matrix class methodsFor: 'examples' stamp: 'jpwj 7/21/2001 14:20'!
example02
	"Matrix example02."
   "Answer the contents of a stream showing various operations
    on the matrix from examples01.  Each acces method has
    an associated 'put' method. e.g. #row:col: - #row:col:put:"
    | matrix stream |
    stream := WriteStream on:''.
    matrix := Matrix example01.
    stream nextPutAll: '** Accessing a Matrix  **'; cr.
    stream nextPutAll: 'Matrix from example01'.
    matrix printOn: stream width: 2 decimal: 0.
    stream nextPutAll: '** Element Access **'; cr;
           nextPutAll: 'matrix row: 1 col: 1 is ';
           nextPutAll: (matrix row: 1 col: 1) printString; cr.
    stream nextPutAll: '** Row Access **'; cr;
           nextPutAll: 'matrix rowAt: 1 is ';
           nextPutAll: (matrix rowAt: 1 ) printString; cr.
    stream nextPutAll: '** Column Access **'; cr;
           nextPutAll: 'matrix columnAt: 1 is ';
           nextPutAll: (matrix columnAt: 1) printString; cr.
    stream nextPutAll: '** matrix transpose **'.
    (matrix transpose) printOn: stream width: 2 decimal: 0.
    ^stream contents! !

!Matrix class methodsFor: 'examples' stamp: 'jpwj 7/21/2001 14:15'!
example03
	"Matrix example03."
   "answer aStream contents containing:
        1) a matrix
        2) its determinant
        3) the matrix inverse
    using gaussJordanInverse"
    | aStream matrix determinant inverse |
    matrix := Matrix testMatrix01. "get the test matrix"
       "make a copy since gaussJordanInverse replaces
        contents of with the inverse."
    inverse := matrix copy.
    determinant := inverse gaussJordanInverse.
    aStream := WriteStream on:' '.
    aStream nextPutAll: '** determinant & inverse using gaussJordanInverse'; cr.
    aStream nextPutAll: 'Orginal Matrix:'.
    matrix printOn: aStream width: 8 decimal: 3.
    aStream nextPutAll: determinant printString,' is calculated determinant.'; cr.
    aStream nextPutAll: '6.2003314e-2 is expected determinant.'; cr.
    aStream nextPutAll: ' Inverse(calculated) of the above Matrix:'.
    inverse printOn: aStream width: 8 decimal: 3.
    aStream nextPutAll: ' Inverse(expected)'.
    (Matrix testMatrix02) printOn: aStream width: 8 decimal: 3.
    ^aStream contents! !

!Matrix class methodsFor: 'examples' stamp: 'jpwj 7/21/2001 14:14'!
example04
	"Matrix example04."
   "answer aStream contents containing:
        1) a matrix
        2) its determinant
        3) the matrix inverse
    using luDecomposition."
    | aStream matrix luMatrix determinant inverse |
    matrix := Matrix testMatrix01. "get the test matrix"
    luMatrix := matrix luDecomposition.
    inverse := luMatrix inverse. "ask the luMatrix for the inverse"
    determinant := luMatrix determinant.
    aStream := WriteStream on:' '.
    aStream nextPutAll: '** determinant & inverse using luDecomposition'; cr.
    aStream nextPutAll: 'Orginal Matrix:'.
    matrix printOn: aStream width: 8 decimal: 3.
    aStream nextPutAll: determinant printString,' is calculated determinant.'; cr.
    aStream nextPutAll: '6.2003314e-2 is expected determinant.'; cr.
    aStream nextPutAll: ' Inverse(calculated) of the above Matrix:'.
    inverse printOn: aStream width: 8 decimal: 3.
    aStream nextPutAll: ' Inverse(expected)'.
    (Matrix testMatrix02) printOn: aStream width: 8 decimal: 3.
    ^aStream contents! !

!Matrix class methodsFor: 'examples' stamp: 'jpwj 7/21/2001 14:14'!
example05
	"Matrix example05."
    "answer aStream contents containing:
        1) a matrix
        2) its calculated  and expected eigenvalues(sorted)
        3) its calculated  and expected eigenvectors(sorted)
    by jacobiEigenSystem which uses jacobiTransformation"
    | aStream matrix eigenvalues eigenvectors |
    matrix := Matrix testMatrix03. "get the test matrix"
    matrix jacobiEigenSystem.
    eigenvalues := matrix eigenvalues.
    eigenvectors := matrix eigenvectors.
    aStream := WriteStream on:' '.
    aStream nextPutAll: '** eigenvalues & eigenvectors by jacobiEigenSystem'; cr.
    aStream nextPutAll: 'Orginal Matrix:'.
    matrix printOn: aStream width: 8 decimal: 3.
    aStream nextPutAll: ' calculated eigenvalues.'; cr.
    aStream nextPutAll: eigenvalues printString; cr.
    aStream nextPutAll: ' expected eigenvalues.'; cr.
    aStream nextPutAll: #(13.249771 6.2733435 3.4768856) printString; cr.
    aStream nextPutAll: ' calculated eigenvectors.'.
    eigenvectors printOn: aStream width: 12 decimal: 8.
    aStream nextPutAll: ' expected eigenvectors.'.
    (Matrix testMatrix04) printOn: aStream width: 12 decimal: 8.
    ^aStream contents! !

!Matrix class methodsFor: 'examples' stamp: 'jpwj 7/21/2001 14:13'!
example06
	"Matrix example06."
   "answer aStream contents containing:
        1) a matrix
        2) its calculated  and expected eigenvalues(sorted)
        3) its calculated  and expected eigenvectors(sorted)
    by QL method"
    | aStream matrix eigenvalues eigenvectors |
    matrix := Matrix testMatrix03. "get the test matrix"
    matrix realSymmetricEigenSystem: 'vectors'.
    eigenvalues := matrix eigenvalues.
    eigenvectors := matrix eigenvectors.
    aStream := WriteStream on:' '.
    aStream nextPutAll: '** eigenvalues & eigenvectors by QL method'; cr.
    aStream nextPutAll: 'Orginal Matrix:'.
    matrix printOn: aStream width: 8 decimal: 3.
    aStream nextPutAll: ' calculated eigenvalues.'; cr.
    aStream nextPutAll: eigenvalues printString; cr.
    aStream nextPutAll: ' expected eigenvalues.'; cr.
    aStream nextPutAll: #(13.249771 6.2733435 3.4768856) printString; cr.
    aStream nextPutAll: ' calculated eigenvectors.'.
    eigenvectors printOn: aStream width: 12 decimal: 8.
    aStream nextPutAll: ' expected eigenvectors.'.
    (Matrix testMatrix04) printOn: aStream width: 12 decimal: 8.
    ^aStream contents! !

!Matrix class methodsFor: 'examples' stamp: 'jpwj 7/21/2001 14:17'!
exampleReadMe
   "class methods #example01 through #exampleNN demonstrate
some of the features provided by this class.  These examples
are designed to be evaluated in a Workspace with show it(printIt).
For example,  In a workspace evaluate the following line with show it
Matrix examples01

    Each example contains comments explaining the method.
"! !

!Matrix class methodsFor: 'examples' stamp: 'jpwj 7/21/2001 14:12'!
testMatrix01
   "Answer a test matrix one"
    ^Matrix new: 4 @ 4 contents: #(
 1.000      0.7531377  0.6863721   0.7777215
 0.7531377  1.000      0.7361974   0.7340708
 0.6863721  0.7361974  1.000       0.6331719
 0.7777215  0.7340708  0.6331719   1.000 )! !

!Matrix class methodsFor: 'examples' stamp: 'jpwj 7/21/2001 14:11'!
testMatrix02
   "Answer the expected inverse of test matrix one"
    ^Matrix new: 4 @ 4 contents: #(
   3.268  -0.912  -0.645  -1.464
  -0.912   3.211  -1.160  -0.914
  -0.645  -1.160   2.403  -0.169
  -1.464  -0.914  -0.169   2.916  )! !

!Matrix class methodsFor: 'examples' stamp: 'jpwj 7/21/2001 14:17'!
testMatrix03
   "Answer test matrix"
    ^Matrix new: 3 @ 3 contents: #(
  6.0       4.0      1.0
  4.0      11.0      0.0
  1.0       0.0      6.0 )! !

!Matrix class methodsFor: 'examples' stamp: 'jpwj 7/21/2001 14:17'!
testMatrix04
   "Answer test matrix of eigenvectors for testMatrix03"
    ^Matrix new: 3 @ 3 contents: #(
  0.4891064     2.5734204e-1   8.3339667e-1
  8.6961106e-1 -2.1777935e-1  -4.4311259e-1
  6.7465084e-2  9.4146016e-1  -3.3030475e-1 )! !


!MatrixND class methodsFor: 'examples' stamp: 'jpwj 7/21/2001 14:37'!
example01
	"MatrixND example01."
   "Answer a three dimensional MatrixND dimensioned 3 by 3 by 3
    with contents as given.   Result can be viewed as 3 - 3x3 matrices."
    ^MatrixND new: #(3 3 3)
         contents: #(1 1 1 1 1 1 1 1 1
                     2 2 2 2 2 2 2 2 2
                     3 3 3 3 3 3 3 3 3). ! !

!MatrixND class methodsFor: 'examples' stamp: 'jpwj 7/21/2001 14:37'!
example02
	"MatrixND example02."
   "Answer the contents of stream showing various types of
    access to matrix from examples01.  Each method has an
    associated 'put' method e.g. #elementAt: - #elementAt:put:"
    | matrixND stream |
    stream := WriteStream on:''.
    matrixND := MatrixND example01.
    stream nextPutAll: 'Orignal MatrixND dimensioned 3 by 3 by 3'.
    matrixND printOn: stream width: 2 decimal: 0.
    stream nextPutAll: '** Element Access **'; cr;
           nextPutAll: 'matrixND elementAt: #(2 3 1) is ';
           nextPutAll: (matrixND elementAt: #(2 3 1)) printString; cr.
    stream nextPutAll: '** Row Access **'; cr;
           nextPutAll: 'matrixND rowAt: #(1 3 0) is ';
           nextPutAll: (matrixND rowAt: #(1 3 0)) printString; cr.
    stream nextPutAll: '** Matrix Access **'; cr.
    stream nextPutAll: 'matrixND matrixAt: #(2 0 0) is:'.
    (matrixND matrixAt: #(2 0 0))printOn: stream width: 2 decimal: 0.
    stream nextPutAll: 'matrixND matrixAt: #(0 3 0) is:'.
    (matrixND matrixAt: #(0 3 0))printOn: stream width: 2 decimal: 0.
    ^stream contents! !

!MatrixND class methodsFor: 'examples' stamp: 'jpwj 7/21/2001 14:35'!
example03
	"MatrixND example03."
   "Answer a three dimensional MatrixND dimensioned 3 by 3 by 3
    filled with the index vector associated with an element's position.
    Shows that the indices in the index vector (i,j,k) increment
    fastest from the right index (k) to the left index (i).
    This is equivalent to the loop structure:
        1 to: 3 do:[ :i |
            1 to: 3 do:[ :j |
                1 to: 3 do:[ :k |  ]. ]. ]."
    | m |
    m := MatrixND new: #(3 3 3 ).
    1 to: m size do:[ :i |
        m at: i put:( m convertIndex: i) ].
    ^m! !

!MatrixND class methodsFor: 'examples' stamp: 'jpwj 7/21/2001 14:39'!
exampleReadMe
   "class methods #example01 through #exampleNN demonstrate
some of the features provided by this class.  These examples
are designed to be evaluated in a Workspace with show it(printIt).
For example,  In a workspace evaluate the following line with show it
MatrixND example01

    Each example contains comments explaining the method.
"! !


!SquareMatrix class methodsFor: 'examples' stamp: 'jpwj 7/21/2001 14:33'!
exampleReadMe
   "see superClass class methods for examples"! !


!LuMatrix class methodsFor: 'examples' stamp: 'jpwj 7/21/2001 14:43'!
example01
	"LuMatrix example01."
   "Answer the stream contents.  A testMatrix is obtained.
    The luDecomposition is obtained from the testMatrix.
    The lMatrix and uMatrix is obtained from the luMatrix.
    Show the lMatrix, the uMatrix, and the product of lMatrix * uMatrix,
    and the testMatrix.  The product should equal the testMatrix. "
    | aStream matrix luMatrix lMatrix uMatrix ltimesU |
    matrix := Matrix testMatrix01. "get the test matrix"
    luMatrix := matrix luDecomposition."get the luMatrix"
    lMatrix := luMatrix lMatrix.
    uMatrix := luMatrix uMatrix.
    ltimesU := lMatrix * uMatrix.
        "Make sure rows are in original order"
    ltimesU reorderRowsBy: luMatrix rowPermutations.
    aStream := WriteStream on:' '.
    aStream nextPutAll: ' L - Matrix:'.
    lMatrix printOn: aStream width: 10 decimal: 5.
    aStream nextPutAll: ' U - Matrix:'.
    uMatrix printOn: aStream width: 10 decimal: 5.
    aStream nextPutAll: ' L * U :'.
    ltimesU printOn: aStream width: 8 decimal: 3.
    aStream nextPutAll: 'Orginal Matrix:'.
    matrix printOn: aStream width: 8 decimal: 3.
    ^aStream contents! !

!LuMatrix class methodsFor: 'examples' stamp: 'jpwj 7/21/2001 14:42'!
example02
	"LuMatrix example02."
    "Answer the stream contents showing the results from
    solving a system of linear equations:
        testMatrix * inverseMatrix = identityMatrix
  Steps:
    A testMatrix is obtained.
    The luDecomposition is obtained for the testMatrix.
    The inverseMatrix is computed from the known testMatrix
        and identityMatrix.
    Directly uses method #solveForMatrix:  and indirectly
        uses method #solveForVector:"
    | aStream testMatrix luMatrix inverseMatrix identityMatrix |
    testMatrix := Matrix testMatrix01. "get the test matrix"
    luMatrix := testMatrix luDecomposition."get the luMatrix"
        "Create the appropiately dimensioned identity matrix"
    identityMatrix := Matrix identity: testMatrix dimensions.
        "Solve for the inverse Matrix."
    inverseMatrix := luMatrix solveForMatrix: identityMatrix.
    aStream := WriteStream on:''.
    aStream nextPutAll: 'Orginal Matrix:'.
    testMatrix printOn: aStream width: 8 decimal: 3.
    aStream nextPutAll: ' Inverse(calculated) '.
    inverseMatrix printOn: aStream width: 8 decimal: 3.
    aStream nextPutAll: ' Inverse(expected)'.
    (Matrix testMatrix02) printOn: aStream width: 8 decimal: 3.
    ^aStream contents! !

!LuMatrix class methodsFor: 'examples' stamp: 'jpwj 7/21/2001 14:41'!
example03
	"LuMatrix example03."
   "Answer the stream contents showing the results from
    solving a system of linear equations:
        aMatrix * bMatrix = cMatrix
    where aMatrix and cMatrix are known.
    This is a variation on examples02.
    Directly uses method #solveForMatrix:  and indirectly
        uses method #solveForVector:"
    | aStream aMatrix aLuMatrix bMatrix cMatrix bCalc|
    aMatrix := Matrix new: 3 @ 3 contents: #( 6 9 12 17 -2 4 72 -100  1 ).
    bMatrix := Matrix new: 3 @ 3 contents: #( -4 16 20 2 -8 -10 -6 24 30 ).
    cMatrix := Matrix new: 3 @ 3 contents: #( -78 312 390  -96 384 480 -494 1976 2470 ).
    aLuMatrix := aMatrix luDecomposition."get the luMatrix"
        "Solve for the bMatrix."
    bCalc := aLuMatrix solveForMatrix: cMatrix.
    aStream := WriteStream on:''.
    aStream nextPutAll: 'Expected bMatrix:'.
    bMatrix printOn: aStream width: 6 decimal: 0.
    aStream nextPutAll: ' Calculated bMatrix '.
    bCalc printOn: aStream width: 6 decimal: 0.
    ^aStream contents! !

!LuMatrix class methodsFor: 'examples' stamp: 'jpwj 7/21/2001 14:44'!
exampleReadMe
   "class methods #example01 through #exampleNN demonstrate
some of the features provided by this class.  These examples
are designed to be evaluated in a Workspace with show it(printIt).
For example,  In a workspace evaluate the following line with show it
LuMatrix example01

    Each example contains comments explaining the method.
"! !


!TriDiagonalMatrix class methodsFor: 'examples' stamp: 'jpwj 7/21/2001 14:28'!
example01
	"TriDiagonalMatrix example01."
   "create and answer a TriDiagonalMatrix
    NOTE: contents are ordered as diagonal, subdiagonal,
            and superdiagonal"
    | triDiagonal |
    triDiagonal := TriDiagonalMatrix new: 4 @ 4
                contents:#(1 2 3 4 5 6 7 8 9 10).
    ^triDiagonal! !

!TriDiagonalMatrix class methodsFor: 'examples' stamp: 'jpwj 7/21/2001 14:28'!
example02
	"TriDiagonalMatrix example02."
   "create a TriDiagonalMatrix, convert it to a fullMatrix,
    and display it on a stream in fixed width format
    answering the stream contents. "
    | triDiagonal fullMatrix stream |
    stream := WriteStream on: ' '.
    triDiagonal := TriDiagonalMatrix example01.
    fullMatrix := triDiagonal asMatrix.
    fullMatrix printOn: stream width: 3 decimal: 0.
    ^stream contents! !

!TriDiagonalMatrix class methodsFor: 'examples' stamp: 'jpwj 7/21/2001 14:29'!
exampleReadMe
   "class methods #example01 through #exampleNN demonstrate
some of the features provided by this class.  These examples
are designed to be evaluated in a Workspace with show it(printIt).
For example,  In a worspace evaluate the following line with show it
TriDiagonalMatrix examples01

    Each example contains comments explaining the method.
"! !

