'From Squeak3.0 of 4 February 2001 [latest update: #3545] on 21 July 2001 at 2:05:46 pm'!

!Float class methodsFor: 'testing' stamp: 'jpwj 7/21/2001 13:48'!
testBeta
	"Answer contents of a stream showing the test results.  MathPack1 - jpwj 6/1/89"
	"Float testBeta."
 	| zs ws actuals stream |
    stream := WriteStream on:''.
	zs := #(1.0 1.0 0.2 1.0 0.4 1.0 1.0 6.0 5.0 4.0 3.0 2.0 7.0 5.0 4.0).
 	ws := #(1.0 0.2 1.0 0.4 1.0 0.6 0.8 6.0 6.0 6.0 6.0 6.0 7.0 5.0 4.0).
	actuals := #(1.0 5.0 5.0 2.5 2.5 1.666667 1.25 3.607504e-4 7.936508e-4
        1.984127e-3 5.952381e-3 0.0238095 8.325008e-5 1.587302e-3 7.142857e-3).
	stream nextPutAll: '  Test of #beta:  Function'; cr.
	stream nextPutAll: ' Z   W    Actual,Computed'; cr.
    1 to: zs size do:[ :i |
        stream nextPutAll: ((zs at: i) printWidth: 4 decimal: 1);
               nextPutAll: ((ws at: i) printWidth: 4 decimal: 1);
               nextPutAll: '    ';
               nextPutAll: (actuals at: i) printString;
               nextPutAll: ', ';
               nextPutAll: ((zs at: i) beta: (ws at: i)) printString; cr.].
    ^stream contents! !

!Float class methodsFor: 'testing' stamp: 'jpwj 7/21/2001 13:54'!
testBetaIncomplete
   "Answer the contents of a stream showing the test results.
	    Also, tests #betaContinuedFraction:b:    MathPack1 - jpwj 6/1/89"
	"Float testBetaIncomplete."
    | x a b actual stream |
    stream := WriteStream on:''.
    x := #(0.01 0.1 1.0 0.01 0.1 1.0 0.5 0.5 0.9 0.5 1.0 0.5 0.8 0.6
            0.8 0.5 0.6 0.7 0.8 0.7).
    a := #(0.5 0.5 0.5 1.0 1.0 1.0 1.0 5.0 10.0 10.0 10.0
           10.0 20.0 20.0 20.0 20.0 20.0 30.0 30.0 40.0).
    b := #(0.5 0.5 0.5 0.5 0.5 0.5 1.0 5.0 0.5 5.0 5.0 10.0 5.0 10.0
          10.0 20.0 20.0 10.0 10.0 20.0).
    actual := #(0.0637686 0.2048328 1.0 0.0050126 0.0513167 1.0 0.5 0.5
            0.1516409 0.0897827 1.0 0.5 0.4598773 0.2146816 0.9507365 0.5
            0.8979414 0.2241297 0.7586405 0.7001783).
    stream nextPutAll: '  Test of #betaIncomplete  Function'; cr.
    stream nextPutAll: ' X     A    B      Actual      Computed'; cr.
    1 to: x size do:[ :i |
        stream nextPutAll: ((x at: i) printWidth: 4 decimal: 2);
               nextPutAll: ((a at: i) printWidth: 6 decimal: 1);
               nextPutAll: ((b at: i) printWidth: 6 decimal: 1);
               nextPutAll: ((actual at: i) printWidth: 12 decimal: 8);
               nextPutAll: ', ';
               nextPutAll: (((x at: i) betaIncomplete: (a at: i) b: (b at: i))
                        printWidth: 12 decimal: 8); cr.].
    ^stream contents! !

!Float class methodsFor: 'testing' stamp: 'jpwj 7/21/2001 13:49'!
testErrorFunction
   "Answer contents of a stream showing the test results.
    Also tests #gammaIncomplete: and #gammaIncompleteComplement:    MathPack1 - jpwj 6/1/89"
	"Float testErrorFunction."
    | x actual calc diff stream |
    stream := WriteStream on:''.
    x := #(0.0 0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1.0 1.1 1.2 1.3 1.4
            1.5 1.6 1.7 1.8 1.9).
    actual := #(0.0 0.1124629 0.2227026 0.3286268 0.4283924 0.5204999
        0.6038561 0.6778012 0.742101 0.7969082 0.8427008 0.8802051
        0.910314 0.9340079 0.9522851 0.9661051 0.9763484 0.9837905
        0.9890905 0.9927904).
    stream nextPutAll: '  Test of #errorFunction '; cr.
    stream nextPutAll: '    X       Actual   Computed';
        nextPutAll: '    Difference'; cr.
    1 to: x size do:[ :i |
        stream nextPutAll: ((x at: i) printWidth: 6 decimal: 2);
               nextPutAll: ((actual at: i) printWidth: 12 decimal: 7).
        calc := (x at: i) errorFunction.
        diff := (actual at: i) - calc.
        stream nextPutAll: (calc printWidth: 12 decimal: 7);
               nextPutAll: (diff printWidth: 14 decimal: 8); cr.].
    ^stream contents! !

!Float class methodsFor: 'testing' stamp: 'jpwj 7/21/2001 13:52'!
testErrorFunctionComplement
   "Answer contents of a stream showing the test results.
    Also tests #gammaIncomplete: and #gammaIncompleteComplement:   MathPack1 - jpwj 6/1/89"
	"Float testErrorFunctionComplement."
    | x actual calc act diff stream |
    stream := WriteStream on:''.
    x := #(0.0 0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1.0 1.1 1.2 1.3 1.4
            1.5 1.6 1.7 1.8 1.9).
    actual := #(0.0 0.1124629 0.2227026 0.3286268 0.4283924 0.5204999
        0.6038561 0.6778012 0.742101 0.7969082 0.8427008 0.8802051
        0.910314 0.9340079 0.9522851 0.9661051 0.9763484 0.9837905
        0.9890905 0.9927904).
    stream nextPutAll: '  Test of #errorFunctionComplement '; cr.
    stream nextPutAll: '    X       Actual   Computed';
        nextPutAll: '    Difference'; cr.
    1 to: x size do:[ :i |
        act := 1.0 - (actual at: i).
        stream nextPutAll: ((x at: i) printWidth: 6 decimal: 2);
               nextPutAll: (act printWidth: 12 decimal: 7).
        calc := (x at: i) errorFunctionComplement.
        diff := act - calc.
        stream nextPutAll: (calc printWidth: 12 decimal: 7);
               nextPutAll: (diff printWidth: 14 decimal: 8); cr.].
    ^stream contents! !

!Float class methodsFor: 'testing' stamp: 'jpwj 7/21/2001 13:51'!
testGammaIncomplete
   "Answer contents of a stream showing the test results.
    Also tests #gammaIncompleteBySeries: and #gammaIncompleteByContinuedFraction:
    MathPack1 - jpwj 6/1/89"
	"Float testGammaIncomplete."
    | a x actual calc diff stream |
    stream := WriteStream on:''.
    a := #(0.1 0.1 0.1 0.5 0.5 0.5 1.0 1.0 1.0 1.1 1.1 1.1 2.0 2.0
            2.0 6.0 6.0 11.0 26.0 41.0).
    x := #(3.1622777e-2 3.1622777e-1 1.5811388 7.0710678e-2 7.0710678e-1
           3.5355339 0.1 1.0 5.0 1.0488088e-1 1.0488088 5.2440442
           1.4142136e-1 1.4142136 7.0710678 2.4494897 12.247449 16.583124
           25.495098 44.82187).
    actual := #(0.7420263 0.9119753 0.9898955 0.2931279 0.7656418 0.9921661
        0.0951626 0.6321206 0.9932621 0.0757471 0.6076457 0.9933425 0.0091054
        0.4130643 0.993145 0.0387318 0.9825937 0.9404267 0.4863866 0.7359709).
    stream nextPutAll: '  Test of #gammaIncomplete:  Function'; cr.
    stream nextPutAll: ' A         X       Actual   Computed';
        nextPutAll: '    Difference'; cr.
    1 to: a size do:[ :i |
        stream nextPutAll: ((a at: i) printWidth: 6 decimal: 2);
               nextPutAll: ((x at: i) printWidth: 12 decimal: 6);
               nextPutAll: ((actual at: i) printWidth: 10 decimal: 6).
        calc := (a at: i) gammaIncomplete: (x at: i).
        diff := (actual at: i) - calc.
        stream nextPutAll: (calc printWidth: 10 decimal: 6);
               nextPutAll: (diff printWidth: 14 decimal: 8); cr.].
    ^stream contents! !

!Float class methodsFor: 'testing' stamp: 'jpwj 7/21/2001 13:50'!
testGammaIncompleteComplement
   "Answer contents of a stream showing the test results.
    Also tests #gammaIncompleteBySeries: and #gammaIncompleteByContinuedFraction:
    MathPack1 - jpwj 6/1/89"
	"Float testGammaIncompleteComplement."
    | a x actual act calc diff stream |
    stream := WriteStream on:''.
    a := #(0.1 0.1 0.1 0.5 0.5 0.5 1.0 1.0 1.0 1.1 1.1 1.1 2.0 2.0
            2.0 6.0 6.0 11.0 26.0 41.0).
    x := #(3.1622777e-2 3.1622777e-1 1.5811388 7.0710678e-2 7.0710678e-1
           3.5355339 0.1 1.0 5.0 1.0488088e-1 1.0488088 5.2440442
           1.4142136e-1 1.4142136 7.0710678 2.4494897 12.247449 16.583124
           25.495098 44.82187).
    actual := #(0.7420263 0.9119753 0.9898955 0.2931279 0.7656418 0.9921661
        0.0951626 0.6321206 0.9932621 0.0757471 0.6076457 0.9933425 0.0091054
        0.4130643 0.993145 0.0387318 0.9825937 0.9404267 0.4863866 0.7359709).
    stream nextPutAll: '  Test of #gammaIncompleteComplement:  Function'; cr.
    stream nextPutAll: ' A         X       Actual   Computed';
        nextPutAll: '    Difference'; cr.
    1 to: a size do:[ :i |
        act := 1.0 - (actual at: i).
        stream nextPutAll: ((a at: i) printWidth: 6 decimal: 2);
               nextPutAll: ((x at: i) printWidth: 12 decimal: 6);
               nextPutAll: (act printWidth: 10 decimal: 6).
        calc := (a at: i) gammaIncompleteComplement: (x at: i).
        diff := act - calc.
        stream nextPutAll: (calc printWidth: 10 decimal: 6);
               nextPutAll: (diff printWidth: 14 decimal: 8); cr.].
    ^stream contents! !

!Float class methodsFor: 'testing' stamp: 'jpwj 7/21/2001 13:44'!
testGammaLn
   "Answer the contents of a stream showing the test results.
    Also, tests #gammaLn1            MathPack1 - jpwj 6/1/89"
	"Float testGammaLn."
    | x xx actual calc stream |
    stream := WriteStream on:''.
    x := #(1.0 1.2 1.4 1.6 1.8 2.0 0.2 0.4 0.6 0.8 10.0 20.0 30.0).
    actual := #(1.0 0.918169 0.887264 0.893515 0.931384 1.0 4.590845
        2.21816 1.489192 1.16423 362880.0 1.216451e17 8.841762e30).
    stream nextPutAll: '  Test of #gammaLn  Function'; cr.
    stream nextPutAll: ' X      Actual ln    Computed'; cr.
    1 to: x size do:[ :i |
        xx := x at: i.
        "xx >= 1.0
          ifTrue: [ calc := xx gammaLn ]
          ifFalse:[ calc := (xx + 1.0) gammaLn - (xx ln) ]."
        calc := xx gammaLn.
        stream nextPutAll: (xx printWidth: 5 decimal: 1);
               nextPutAll: '    ';
               nextPutAll: ((actual at: i) ln printWidth: 10 decimal: 6) ;
               nextPutAll: '  ';
               nextPutAll: (calc printWidth: 10 decimal: 6) ; cr.].
    ^stream contents! !

!Float class methodsFor: 'testing' stamp: 'jpwj 7/21/2001 13:55'!
testfRatioSignificance
	"Float testfRatioSignificance."
   "Answer the contents of a stream showing the test results.
        Test of  #fRatioSignificance:f2:
    f is the ratio of the larger variance to the smaller variance.
    nu1 and nu2 are the respective number of degrees of freedom
    for the two variances.  Number of degrees of freedom is one less
    the total number of values used to compute the variance.
    Test values from CRC, Standard Math Tables, 24th edition.
        MathPack1 - jpwj 6/1/89"
    | f nu1 nu2 actual stream calcValue |
    stream := WriteStream on:''.
    actual :=
         #(0.90 0.90 0.90  0.95 0.95 0.95  0.99 0.99 0.99 0.995 0.995 0.995 0.999 0.999 0.999  ).
    nu1 := #(24  60   10    15   60  12     10   60   20     8    120   10    12   60    12).
    nu2 := #(24  19   17    15   13  29     10   22   60     8     17   60    12   18    30).
    f := #( 1.70 1.7 2.0   2.4  2.3  2.1   4.85 2.5  2.2    7.5   3.1   2.9  7.0   4.0   4.0).
    stream nextPutAll: '  Test of #fRatioSignificance:f2:  '; cr.
    stream nextPutAll: ' Actual  Computed  #deg.of  #deg.of     F'; cr.
    stream nextPutAll: ' F-Dist   F-Dist   freedom  freedom   Ratio'; cr.
    1 to: f size do:[ :i |
        calcValue := (f at: i) fRatioSignificance: (nu1 at: i) f2: (nu2 at: i).
        stream
               nextPutAll: ((actual at: i) printWidth: 6 decimal:3);
               nextPutAll: (1.0 - calcValue printWidth: 9 decimal: 3);
               nextPutAll: ((nu1 at: i) printWidth: 9 decimal: 0);
               nextPutAll: ((nu2 at: i) printWidth: 9 decimal: 0);
               nextPutAll: ((f at: i) printWidth: 10 decimal: 2); cr.
        ].
    ^stream contents! !


!Integer class methodsFor: 'testing' stamp: 'jpwj 7/21/2001 13:42'!
testBinomialCoefficient
	"Answer contents of a stream showing the test results.  MathPack1 - jpwj 6/1/89"
	"Integer testBinomialCoefficient."
    | n k actual stream |
    stream := WriteStream on:''.
    n := #(1 6 6 6 15 15 15 15 15 15 15 25 25 25 25 25 25 25 25 25).
    k := #(0 1 3 5 1 3 5 7 9 11 13 1 3 5 7 9 11 13 15 17).
    actual := #(1 6 20 6 15 455 3003 6435 5005 1365 105 25 2300 53130
        480700 2042975 4457400 5200300 3268760 1081575).
    stream nextPutAll: ' N   K    Actual   Computed'; cr.
    1 to: n size do:[ :i |
        stream nextPutAll: ((n at: i) printWidth: 4 decimal: 0);
               nextPutAll: ((k at: i) printWidth: 4 decimal: 0);
               nextPutAll: '  ';
               nextPutAll: ((actual at: i) printWidth: 8 decimal: 0);
               nextPutAll:( ((n at: i) binomialCoefficient: (k at: i))
                                printWidth: 10 decimal: 0); cr.].
    ^stream contents! !


!String class methodsFor: 'testing' stamp: 'jpwj 7/21/2001 13:58'!
testasFloat
	"String testasFloat."
   "Answer the stream contents showing the test of method String asFloat. MathPack jpwj "
    | aStream string vector |
    aStream := WriteStream on:''.
      "set of test String"
    string := '1 1.1 .11 0.1 -1 -1.1 -.11 -0.1 1.e-1 -1.1e-1 .1e2 '.
    aStream
        nextPutAll:' **Test of String asFloat method**'; cr;
        nextPutAll:'test string: '; cr;
        nextPutAll: string printString; cr.
      "separate individual numbers and convert to a vector."
    "vector := string asArrayOfSubstrings asVector."
    vector := string substrings asVector.
      "convert elements in vector from string to numbers"
    vector contentsFloat.
      "put results on stream"
    aStream
        nextPutAll:'resulting vector of numbers: '; cr;
        nextPutAll: vector printString; cr.
    ^aStream contents! !


!Vector class methodsFor: 'examples' stamp: 'jpwj 7/21/2001 14:03'!
exampleReadMe
   "class methods #example01 through #exampleNN demonstrate
some of the features provided by this class.  These examples
are designed to be evaluated in a Workspace with show it(printIt).
For example,  In a workspace evaluate the following line with show it
Vector examples01

    Each example contains comments explaining the method.
"! !

!Vector class methodsFor: 'examples' stamp: 'jpwj 7/21/2001 14:03'!
examples01
	"Vector examples01."
   "Answer a stream containing testVector with missing values
    denoted by nil, and statistics about the values in testVector.
    NOTE: Any single statistic is obtained by sending the appropiate
    message name to vector.  Valid message names are given in keys
    below.  The statement, mean := vector mean, results in the mean.
    Other combinations are provided such as countWithMean,
    minimumAndMaximum, etc."
    | testVector statsDictionary keys key stat stream |
    testVector := #( 16 100 -6 nil 84 nil 53) asVector.
        "convert nil symbols to UndefinedObject"
    testVector convertNilSymbols.
        "get the dictionary of statistics"
    statsDictionary := testVector moments.
    keys := #( 'count' 'minimum' 'maximum' 'mean' 'median'
               'variance' 'standardDeviation' 'absoluteDeviation'
               'skewness' 'kurtosis' ).
        "Now place results on a stream."
    stream := WriteStream on:''.
    stream nextPutAll: ' Test Vector:'; cr.
    stream nextPutAll: testVector printString; cr.
    1 to: keys size do:[ :i |
        key := keys at: i.
        stat := statsDictionary at: key.
        stream nextPutAll: (key printRightWidth: 18); nextPutAll:': '.
        stream nextPutAll: (stat printWidth: 9 decimal: 4); cr. ].
    ^stream contents! !

!Vector class methodsFor: 'examples' stamp: 'jpwj 7/21/2001 14:01'!
examples02
	"Vector examples02."
   "Answer the contents of a Stream showing the results
    vector operations (*,+,-,/) with a scalar and #negated, #reciprocal)
    and vector (*,+,-,/) operations with vector.
    Answer vector should equal the starting vector.
    All operations are element wise operations on the vector.
    NOTE: Scalars must appear to the right of the vector
      for operation to be valid with a scalar.
        RIGHT: Vector + Scalar
        WRONG: Scalar + Vector  "
    | vector answer stream |
    vector := #( 23 nil 14 nil 2 32 ) asVector convertNilSymbols.
    answer := vector * 2  + 10 - 10 / 2.
    answer := answer negated.
    answer := answer reciprocal.
    answer := answer reciprocal.
    answer := answer negated.
        "Put results on stream"
    stream := WriteStream on:''.
    stream nextPutAll:  '** Vector operations (*,+,-,/) with a Scalar. **'; cr.
    stream nextPutAll:'  **         and #negated, #reciprocal          **'; cr.
    stream nextPutAll:  '   Test Vector: '; nextPutAll: vector printString;
        cr; nextPutAll: ' Answer Vector: '; nextPutAll: answer printString;
        cr.
    stream nextPutAll:  '** Vector operations (*,+,-,/) with a vector. **'; cr.
    answer := vector + vector * vector / vector - vector.
    stream nextPutAll:  '  Test Vector: '; nextPutAll: vector printString;
        cr; nextPutAll: 'Answer Vector: '; nextPutAll: answer printString;
        cr.
    ^stream contents! !

!Vector class methodsFor: 'examples' stamp: 'jpwj 7/21/2001 14:01'!
examples03
	"Vector examples03."
   "For a vector with NO nil elements, the dotProduct and sum of the
    elements squared should be the same. "
    | vector dot sumOfSquares stream |
    vector := #( 23 14 2 32 ) asVector.
    dot := vector dotProduct.
    sumOfSquares := (vector countWithSumSumSquares) at: 3.
        "Put results on stream"
    stream := WriteStream on:''.
    stream nextPutAll: 'Test Vector: '; nextPutAll: vector printString;
        cr; nextPutAll: '  dotProduct: '; nextPutAll: dot printString;
        cr; nextPutAll: 'sumOfSquares: ';
            nextPutAll: sumOfSquares printString; cr.
    ^stream contents! !

!Vector class methodsFor: 'examples' stamp: 'jpwj 7/21/2001 14:00'!
examples04
	"Vector examples04."
   "For a vector with NO nil elements, the crossProduct
    should be the same as the product of two appropiately dimensioned
    matrices. The results of a vector * bMatrix and aMatrix * vector
    should be the same.
      Show the results of the operations.
    elements squared should be the same. "
    | vector aMatrix bMatrix stream |
    vector := #( 23 14 2 32 ) asVector.
    aMatrix := Matrix new: (vector size) @ 1 contents: vector.
    bMatrix := Matrix new: 1 @ (vector size) contents: vector.
        "Put results on stream"
    stream := WriteStream on:''.
    stream nextPutAll: 'Test Vector '.
    vector printOn: stream width: 3 decimal: 0.
    stream nextPutAll: '  vector crossProduct  '.
    (vector crossProduct) printOn: stream width: 5 decimal: 0.
    stream nextPutAll: '  aMatrix * bMatrix'.
    (aMatrix * bMatrix) printOn: stream width: 5 decimal: 0.
    stream cr; nextPutAll: 'vector * bMatrix is '.
    (vector * aMatrix) printOn: stream width: 5 decimal: 0.
    stream  cr; nextPutAll: 'aMatrix * vector is '.
    (bMatrix * vector) printOn: stream width: 5 decimal: 0.
    stream cr.
    ^stream contents! !

!Vector class methodsFor: 'examples' stamp: 'jpwj 7/21/2001 13:59'!
examples05
	"Vector examples05."
   "Answer the contents of a stream showing the results from
    #formComplexNumbers and #formComplexNumbersPairwise on a vector."
    | vector1 vector2 stream |
    vector1 := #( 1i:2  -3i:4  6) asVector.
    vector2 := #( 1 2 -3 4) asVector.
        "Put results on stream"
    stream := WriteStream on:''.
    stream nextPutAll:  'vector1: '; nextPutAll: vector1 printString;
           nextPutAll: '  size = '; nextPutAll: (vector1 size) printString;cr.
    stream nextPutAll:  'vector1 formComplexNumbers '; cr;
        nextPutAll: (vector1 formComplexNumbers) printString;
        nextPutAll: '  size = ';
        nextPutAll: ((vector1 formComplexNumbers) size) printString; cr.
    stream nextPutAll:  'vector2: '; nextPutAll: vector2 printString;
           nextPutAll: '  size = '; nextPutAll: (vector2 size) printString;cr.
    stream nextPutAll:  'vector2 formComplexNumbersPairwise '; cr;
        nextPutAll: (vector2 formComplexNumbersPairwise) printString;
        nextPutAll: '  size = ';
        nextPutAll: ((vector2 formComplexNumbersPairwise) size) printString; cr.
    ^stream contents! !


!Vector class reorganize!
('examples' exampleReadMe examples01 examples02 examples03 examples04 examples05)
!

